C
C Matrix - Vektor Multiplikation (BLAS)
C
      PROGRAM Example4b
      IMPLICIT NONE

      INTEGER PAR_DIM
      PARAMETER( PAR_DIM = 3000 )

      DOUBLE PRECISION Matrix_A( PAR_DIM , PAR_DIM )      
      DOUBLE PRECISION Feld_B( PAR_DIM )      
      DOUBLE PRECISION Feld_C( PAR_DIM )      
      DOUBLE PRECISION S

      INTEGER N , M , I , J , K , K_IT , Loop
      

C
C Beispiel 1
C
      N = 3000
      M = N
      K_IT = 200

      DO J = 1 , M 
         DO I = 1 , N
            Matrix_A(I,J)   = dble( I*J )
         ENDDO
      ENDDO
      DO I = 1 , N
         Feld_B(I)   = 0.d0
      ENDDO
      DO J = 1 , N
         Feld_C(J)   = 1.d0/j
      ENDDO


      DO Loop = 1 , K_IT  

         call DGEMV('n' , M ,N, 1.d0,Matrix_A,PAR_DIM,
     $        Feld_C,1,1.d0,Feld_B,1)

      ENDDO

      S = 0.d0
      DO I = 1 , N
         S = S + Feld_B( I )
      ENDDO

      write(*,*) " N = ",N
      write(*,*) " S = ", S

      END
